/* eslint-disable max-nested-callbacks */

(function ($, Drupal) {

  'use strict';

  Drupal.behaviors.xpTrigger = {
    attach: function (context) {
      $('[data-xp-trigger]', context).once('xp-trigger').each(function () {
        var $trigger = $(this);
        $trigger.on('click', function (event) {
          var item = $trigger.data('xp-trigger');

          var triggered = Drupal.Xp.showVariant(item, function () {
            // Display variant and highlight it.
            Drupal.Xp.getVariantElement(item)
              .css({opacity: '0.2'})
              .animate({opacity: '1'}, 1000);

            // Update ?_variant= query string parameter.
            if (Drupal.XpTest) {
              Drupal.XpTest.updateHistory(item);
            }
          });

          // If show variant is triggered then prevent the default href
          // from being triggered.
          if (triggered) {
            event.preventDefault();
          }
        });
      });
    }
  };

}(jQuery, Drupal));
