/**
 * Tracking and sdk code which is added to every page.
 */

/* eslint-disable  no-undef */

(function ($, Drupal) {

  'use strict';

  XpExampleIntegration = {};

  /**
   * Get decisions and display variants.
   *
   * @param {Array} items
   *   An array of item objects which contain type, and id properties.
   */
  XpExampleIntegration.triggerDecisions = function (items) {
    // Below is just some basic debugging and testing code.
    items.forEach(function (item) {
      console.log('Found EXAMPLE: ' + Object.values(item).join('/'));

      Drupal.Xp.getVariantsIds(item).forEach(function (variant) {
        var url = window.location.href.split('?')[0];
        console.log('Test EXAMPLE \'' + variant + '\' variant: ' + url + '?_xp_example=' + encodeURIComponent(variant));
      });
    });

    // Get the current variant id from the query string.
    var currentVariantId = window.location.search.replace('?_xp_example=', '');

    // Loop thru all the items.
    //
    // In a real world situation you would call your external personalization
    // decision engine's API with the item data and get back the
    // variant as a decision.
    items.forEach(function (item) {

      // Loop thru all item variants.
      Drupal.Xp.getVariantsIds(item).forEach(function (variant) {

        // If we find a matching variant id, show this variant.
        if (variant === currentVariantId) {
          item.variant = variant;
          Drupal.Xp.showVariant(item);
          console.log('%c Displaying EXAMPLE variant: ' + Object.values(item).join('/'), 'background: #222; color: #bada55');
        }

      });
    });
  };

}(jQuery, Drupal));
